diff --git a/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java b/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java
index fa95cd452..63e34bf9a 100644
--- a/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java
+++ b/src/main/java/net/minecraft/client/gui/achievements/pages/OverworldPage.java
@@ -1,9 +1,418 @@
 package net.minecraft.client.gui.achievements.pages;
 
+import net.minecraft.client.Minecraft;
+import net.minecraft.client.gui.achievements.GuiAchievements;
+import net.minecraft.client.gui.achievements.data.AchievementPage;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.WeightedRandomBag;
+import net.minecraft.core.achievement.Achievement;
+import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 
-public class OverworldPage extends DefaultPage{
-    public OverworldPage() {
-        super("gui.achievements.page.overworld", Blocks.GRASS.getDefaultStack());
+import java.util.Random;
+import java.util.function.BiFunction;
+
+public class OverworldPage extends AchievementPage {
+    protected final Minecraft mc = Minecraft.getMinecraft(this);
+    protected final ItemStack icon;
+    @NotNull
+    protected final String key;
+
+    public OverworldPage(String key, ItemStack icon) {
+        this.key = key;
+        this.icon = icon;
+    }
+
+    @Override
+    public @NotNull String getName() {
+        return I18n.getInstance().translateNameKey(key);
+    }
+
+    @Override
+    public @NotNull String getDescription() {
+        return I18n.getInstance().translateDescKey(key);
+    }
+
+    @Override
+    public @NotNull Achievement onOpenAchievement() {
+        return Achievements.BUILD_WORKBENCH;
+    }
+
+    protected static final int ORE_COAL = 0;
+    protected static final int ORE_IRON = 1;
+    protected static final int ORE_GOLD = 2;
+    protected static final int ORE_DIAMOND = 3;
+    protected static final int ORE_REDSTONE = 4;
+    protected static final int ORE_LAPIS = 5;
+    protected static final Block[] STONE_ORES = new Block[]     { Blocks.ORE_COAL_STONE,    Blocks.ORE_IRON_STONE,      Blocks.ORE_GOLD_STONE,      Blocks.ORE_DIAMOND_STONE,       Blocks.ORE_REDSTONE_STONE,      Blocks.ORE_LAPIS_STONE};
+    protected static final Block[] GRANITE_ORES = new Block[]   { Blocks.ORE_COAL_GRANITE,  Blocks.ORE_IRON_GRANITE,    Blocks.ORE_GOLD_GRANITE,    Blocks.ORE_DIAMOND_GRANITE,     Blocks.ORE_REDSTONE_GRANITE,    Blocks.ORE_LAPIS_GRANITE};
+    protected static final Block[] LIMESTONE_ORES = new Block[] { Blocks.ORE_COAL_LIMESTONE,Blocks.ORE_IRON_LIMESTONE,  Blocks.ORE_GOLD_LIMESTONE,  Blocks.ORE_DIAMOND_LIMESTONE,   Blocks.ORE_REDSTONE_LIMESTONE,  Blocks.ORE_LAPIS_LIMESTONE};
+    protected static final Block[] BASALT_ORES = new Block[]    { Blocks.ORE_COAL_BASALT,   Blocks.ORE_IRON_BASALT,     Blocks.ORE_GOLD_BASALT,     Blocks.ORE_DIAMOND_BASALT,      Blocks.ORE_REDSTONE_BASALT,     Blocks.ORE_LAPIS_BASALT};
+
+    @Override
+    public IconCoordinate getBackgroundTile(GuiAchievements guiAchievements, int layer, Random random, int tileX, int tileY) {
+        random.setSeed(random.nextLong() + key.hashCode()); // makes seed different for each instance of this class :)
+        // expect x range from  0  to 45
+        // expect y range from -12 to 50
+        final int sandLayer = -20;
+        final int dirtLayer = 2;
+        final int bedrockLayer = 35;
+        final int stoneLayer = bedrockLayer - (int) ((bedrockLayer - dirtLayer) * 0.5f);
+        final int basaltLayer = bedrockLayer - (int) ((bedrockLayer - dirtLayer) * 0.25f);
+
+        final int graniteColumn = 5;
+        final int limestoneColumn = 50;
+
+        final int offsetX = tileX + random.nextInt(3) - random.nextInt(3);
+        final int offsetY = tileY + random.nextInt(3) - random.nextInt(3);
+
+        if (offsetY <= sandLayer){
+            return getTextureFromBlock(Blocks.SAND);
+        } else if (offsetY <= dirtLayer) {
+            return getTextureFromBlock(Blocks.DIRT);
+        } else if (offsetY >= bedrockLayer) {
+            return getTextureFromBlock(Blocks.BEDROCK);
+        } else {
+            if (offsetY >= basaltLayer){
+                return getOreFromStone(Blocks.BASALT, random, tileX, tileY);
+            } else if (offsetY >= stoneLayer){
+                return getOreFromStone(Blocks.STONE, random, tileX, tileY);
+            } else {
+                if (offsetX <= graniteColumn){
+                    return getOreFromStone(Blocks.GRANITE, random, tileX, tileY);
+                } else if (offsetX >= limestoneColumn) {
+                    return getOreFromStone(Blocks.LIMESTONE, random, tileX, tileY);
+                }
+                return getOreFromStone(Blocks.STONE, random, tileX, tileY);
+            }
+        }
+    }
+
+    @Override
+    public void postProcessBackground(GuiAchievements gui, Random random, GuiAchievements.BGLayer layer, int orgX, int orgY) {
+        random.setSeed(random.nextLong() + key.hashCode()); // makes seed different for each instance of this class :)
+        if (layer.id == 0) {
+
+            int y = 5;
+            int delta = 0;
+            int tYMin = -2;
+            int tYMax = -6;
+            int lowestY = 0;
+            for (int _x = -100; _x < 100; _x++) {
+                delta += random.nextInt(2) - random.nextInt(2);
+                delta = MathHelper.clamp(delta, -3, 3);
+                int sign = (int) Math.signum(delta);
+                int _d = Math.abs(delta);
+                if (_d != 0) {
+                    y += sign * random.nextInt(_d);
+                }
+
+                if (y > tYMax) {
+                    delta -= 1;
+                }
+                if (y < tYMin) {
+                    delta += 1;
+                }
+                if (y > lowestY) y = lowestY;
+
+                for (int rY = y; rY - orgY >= 0; rY--) {
+                    if (rY == y) {
+                        layer.put(TextureRegistry.getTexture("minecraft:block/grass_side"), _x - orgX, rY - orgY);
+                    } else {
+                        layer.put(null, _x - orgX, rY - orgY);
+                    }
+                    gui.getLayer(1).put(null, _x - orgX, rY - orgY);
+                }
+            }
+
+            int[] brickPos = null;
+            int[] cobblePos = null;
+            int lastY = 0;
+            int cave = -1;
+            for (int _x = -100; _x <= 100; _x++) {
+                if (random.nextInt(20) == 0 && cave <= 0) {
+                    cave = 20 + random.nextInt(5) - random.nextInt(5);
+                }
+                if (cave > 0){
+                    lastY = (25 + random.nextInt(4) - random.nextInt(4));
+                    carveCircle(gui, layer, _x - orgX, lastY - orgY, 2 + random.nextInt(3));
+                }
+                if (cave == 0 && (-10 <= _x && _x <= 40)) {
+                    brickPos = new int[]{_x, lastY};
+                }
+                cave--;
+            }
+            cave = -1;
+            for (int _x = -100; _x <= 100; _x++) {
+                if (random.nextInt(10) == 0 && cave <= 0) {
+                    cave = 5 + random.nextInt(5) - random.nextInt(5);
+                }
+                if (cave > 0){
+                    carveCircle(gui, layer, _x - orgX, (10 + random.nextInt(2) - random.nextInt(2)) - orgY, random.nextInt(3));
+                }
+                cave--;
+            }
+
+            if (brickPos == null) {
+                brickPos = new int[]{5 + random.nextInt(20) + random.nextInt(20), 15 + random.nextInt(10)};
+            }
+
+            placeStructure(gui, dungeonBrick, brickPos[0] - orgX,brickPos[1] - orgY, (struct, cache) -> {
+                if (cache == null) {
+                    if (struct == chest || struct == spawner) {
+                        return struct;
+                    }
+                    return null;
+                }
+                return struct;
+            });
+            placeStructure(gui, dungeonCobble, -orgX + 5 + random.nextInt(20) + random.nextInt(20),-orgY + 5 + random.nextInt(5), (struct, cache) -> {
+                if (cache == null) {
+                    if (struct == chest || struct == spawner) {
+                        return struct;
+                    }
+                    return null;
+                }
+                return struct;
+            });
+        } else if (layer.id == 1) {
+            // Remove covered icons
+            IconCoordinate[] foreground = gui.getLayer(0).getData();
+            IconCoordinate[] background = layer.getData();
+            for (int i = 0; i < background.length; i++) {
+                if (foreground[i] != null && foreground[i] != spawner){
+                    background[i] = null;
+                }
+            }
+        }
+    }
+
+    protected void carveCircle(GuiAchievements gui, GuiAchievements.BGLayer layer, int centerX, int centerY, int radius){
+        for (int i = centerX - radius; i <= centerX + radius ; i++) {
+            for (int j = centerY - radius; j < centerY + radius; j++) {
+                double diffX = (i + 0.5) - centerX;
+                double diffY = (j + 0.5) - centerY;
+                if ((diffX * diffX) + (diffY * diffY) < radius * radius){
+                    layer.put(null, i, j);
+                }
+            }
+        }
+    }
+
+    protected void placeStructure(GuiAchievements gui, PageStructure structure, int tileX, int tileY, @Nullable BiFunction<IconCoordinate, IconCoordinate, IconCoordinate> coordinateProcessor) {
+        if (coordinateProcessor == null) {
+            coordinateProcessor = (i, i2) -> i;
+        }
+        for (int layer = 0; layer < structure.layers; layer++) {
+            GuiAchievements.BGLayer cache = gui.getLayer(layer);
+            if (cache != null) {
+                for (int _x = 0; _x < structure.width; _x++) {
+                    for (int _y = 0; _y < structure.height; _y++) {
+                        IconCoordinate coordinate = structure.getIcon(_x, _y, layer);
+                        cache.put(coordinateProcessor.apply(coordinate, cache.get(tileX + _x, tileY + _y)), tileX + _x, tileY + _y);
+                    }
+                }
+            }
+        }
+    }
+
+    private static final WeightedRandomBag<Integer> oreBag = new WeightedRandomBag<>();
+
+    private IconCoordinate getOreFromStone(Block stoneBlock, Random random, int tileX, int tileY){
+        oreBag.clear();
+
+        random.setSeed(random.nextLong());
+
+        final int coalStart = 2;
+        final int coalEnd = 20;
+
+        final int ironStart = 2;
+        final int ironEnd = 25;
+
+        final int goldStart = 20;
+        final int goldEnd = 35;
+
+        final int diamondStart = 25;
+        final int diamondEnd = 35;
+
+        final int lapisStart = 25;
+        final int lapisEnd = 35;
+
+        final int redstoneStart = 20;
+        final int redstoneEnd = 35;
+
+        oreBag.addEntry(-1, 300);
+
+        if (tileY >= coalStart && tileY <= coalEnd){
+            oreBag.addEntry(ORE_COAL, 15);
+        }
+
+        if (tileY >= ironStart && tileY <= ironEnd){
+            oreBag.addEntry(ORE_IRON, 15);
+        }
+
+        if (tileY >= goldStart && tileY <= goldEnd){
+            oreBag.addEntry(ORE_GOLD, 3);
+        }
+
+        if (tileY >= diamondStart && tileY <= diamondEnd){
+            oreBag.addEntry(ORE_DIAMOND, 1);
+        }
+
+        if (tileY >= lapisStart && tileY <= lapisEnd){
+            oreBag.addEntry(ORE_LAPIS, 2);
+        }
+
+        if (tileY >= redstoneStart && tileY <= redstoneEnd){
+            oreBag.addEntry(ORE_REDSTONE, 5);
+        }
+
+        int oreIndex = oreBag.getRandom(random);
+
+        if (oreIndex >= 0){
+            if (stoneBlock == Blocks.STONE){
+                return getTextureFromBlock(STONE_ORES[oreIndex]);
+            } else if (stoneBlock == Blocks.BASALT) {
+                return getTextureFromBlock(BASALT_ORES[oreIndex]);
+            } else if (stoneBlock == Blocks.GRANITE) {
+                return getTextureFromBlock(GRANITE_ORES[oreIndex]);
+            } else if (stoneBlock == Blocks.LIMESTONE) {
+                return getTextureFromBlock(LIMESTONE_ORES[oreIndex]);
+            }
+        }
+
+        return getTextureFromBlock(stoneBlock);
+    }
+
+    @Override
+    public @NotNull ItemStack getIcon() {
+        return icon;
+    }
+
+    @Override
+    public int backgroundLayers() {
+        return 2;
+    }
+
+    @Override
+    public int backgroundColor() {
+        return 0x76b6ff;
+    }
+
+    @Override
+    public IconCoordinate getAchievementIcon(Achievement achievement) {
+        return TextureRegistry.getTexture(achievement.getType().texture);
+    }
+
+    @Override
+    public int lineColorLocked(boolean isHovered) {
+        return 0x000000;
+    }
+
+    @Override
+    public int lineColorUnlocked(boolean isHovered) {
+        return 0x707070;
+    }
+
+    @Override
+    public int lineColorCanUnlock(boolean isHovered) {
+        return 0x00ff00;
+    }
+
+    private static final IconCoordinate chest = TextureRegistry.getTexture("minecraft:block/chest_planks_oak_front");
+    private static final IconCoordinate spawner = getTextureFromBlock(Blocks.MOBSPAWNER);
+
+    protected static PageStructure dungeonBrick = new PageStructure(new Object[][][]
+        {
+            {
+                {Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY,  Blocks.BRICK_CLAY},
+                {Blocks.BRICK_CLAY, null,              null,              null,              null,              null,               Blocks.BRICK_CLAY},
+                {Blocks.BRICK_CLAY, null,              null,              null,              null,              null,               Blocks.BRICK_CLAY},
+                {Blocks.BRICK_CLAY, null,              null,              Blocks.MOBSPAWNER, null,              chest,              Blocks.BRICK_CLAY},
+                {Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY,  Blocks.BRICK_CLAY},
+            },
+            {
+                {Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY,  Blocks.BRICK_CLAY},
+                {Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY,  Blocks.BRICK_CLAY},
+                {Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY,  Blocks.BRICK_CLAY},
+                {Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY,  Blocks.BRICK_CLAY},
+                {Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY, Blocks.BRICK_CLAY,  Blocks.BRICK_CLAY},
+            },
+        }
+    );
+
+    protected static PageStructure dungeonCobble = new PageStructure(new Object[][][]
+        {
+            {
+                {Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY,  Blocks.COBBLE_STONE},
+                {Blocks.COBBLE_STONE,       null,                      null,                      null,                      null,                      null,                       Blocks.COBBLE_STONE_MOSSY},
+                {Blocks.COBBLE_STONE_MOSSY, null,                      null,                      null,                      null,                      null,                       Blocks.COBBLE_STONE},
+                {Blocks.COBBLE_STONE,       chest,                     null,                      Blocks.MOBSPAWNER,         null,                      null,                       Blocks.COBBLE_STONE_MOSSY},
+                {Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,        Blocks.COBBLE_STONE},
+            },
+            {
+                {Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,        Blocks.COBBLE_STONE},
+                {Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,        Blocks.COBBLE_STONE},
+                {Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,        Blocks.COBBLE_STONE},
+                {Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE_MOSSY, Blocks.COBBLE_STONE,        Blocks.COBBLE_STONE},
+                {Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,       Blocks.COBBLE_STONE,        Blocks.COBBLE_STONE},
+            },
+        }
+    );
+
+    public static class PageStructure {
+        private final IconCoordinate[] data;
+        public final int width;
+        public final int height;
+        public final int layers;
+        public PageStructure(Object[][][] structure) {
+            this.layers = structure.length;
+            this.width = structure[0][0].length;
+            this.height = structure[0].length;
+
+            data = new IconCoordinate[width * height * layers];
+            for (int l = 0; l < layers; l++) {
+                for (int x = 0; x < width; x++) {
+                    for (int y = 0; y < height; y++) {
+                        Object o = structure[l][y][x];
+                        IconCoordinate c = null;
+                        if (o instanceof Block) {
+                            c = getTextureFromBlock((Block) o);
+                        } else if (o instanceof IconCoordinate) {
+                            c = (IconCoordinate) o;
+                        }
+                        data[makeIndex(x, y, l)] = c;
+                    }
+                }
+            }
+        }
+        public PageStructure(int width, int height, int layers){
+            this.width = width;
+            this.height = height;
+            this.layers = layers;
+            this.data = new IconCoordinate[width * height * layers];
+        }
+
+        public PageStructure setIcon(IconCoordinate icon, int x, int y, int layer) {
+            if (x < 0 || x >= width || y < 0 || y >= height || layer < 0 || layer >= layers) return this;
+            data[makeIndex(x, y, layer)] = icon;
+            return this;
+        }
+
+        public IconCoordinate getIcon(int x, int y, int layer){
+            if (x < 0 || x >= width || y < 0 || y >= height || layer < 0 || layer >= layers) return null;
+            return data[makeIndex(x, y, layer)];
+        }
+
+        private int makeIndex(int x, int y, int layer) {
+            return x % width + y * width + layer * (width * height);
+        }
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 394f782ed..c7ded604a 100644
--- a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -291,7 +291,7 @@ public abstract class OptionsPages
             .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.sound_test", () -> mc.displayGuiScreen(new GuiSoundTest(mc.currentScreen))))
             .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.texture_viewer", () -> mc.displayGuiScreen(new GuiTextureViewer(mc.currentScreen))))
             .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.biome_finder", () -> {
-                BiomeFinder.main(new String[0]);
+                new Thread(() -> BiomeFinder.main(new String[0])).start();
                 Global.accessor = mc;
             }))
             .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.datadumper", () ->{
diff --git a/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java b/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
index 0ad03e175..51ca70739 100644
--- a/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
+++ b/src/main/java/net/minecraft/client/gui/popup/MessageBoxComponent.java
@@ -10,6 +10,7 @@ import org.lwjgl.opengl.GL11;
 
 import java.util.ArrayList;
 import java.util.Arrays;
+import java.util.Collections;
 import java.util.List;
 
 public class MessageBoxComponent
@@ -38,47 +39,53 @@ public class MessageBoxComponent
         setupText(text, chars);
     }
 
-    private void setupText(String text, int chars) {
+    private void setupText(String text, int limit) {
         lines.clear();
 
-        String[] newlines = text.split("\\n");
-        List<String> completeSplit = new ArrayList<>();
-        ArrayList<String> newlineSplit = new ArrayList<>(Arrays.asList(newlines));
+        List<String> completeSplit = new ArrayList<>(); //the processed wrapped text, each entry is one line
+        ArrayList<String> newlineSplit = new ArrayList<>(Arrays.asList(text.split("\\n"))); //text split based only on newlines before processing
 
         String lastFormat = "";
 
         for (String s : newlineSplit) {
-            String[] words = s.split(" ");
+            ArrayList<String> words = new ArrayList<>(Arrays.asList(s.split(" ")));
+            ArrayList<String> limitedSizeWords = new ArrayList<>(); //all words here should not be larger than the limit
             StringBuilder line = new StringBuilder();
             line.append(lastFormat);
-            String currentFormat = lastFormat;
-            boolean formatChanged = false;
-            for (int i = 0; i < words.length; i++) {
-                String word = words[i];
+            //split words larger than the limit into multiple that can fit
+            for (String word : words) {
+                if (word.length() > limit) {
+                    ArrayList<String> split = new ArrayList<>();
+                    for (int j = 0; j <= word.length() / limit; j++) {
+                        split.add(word.substring(j * limit, Math.min((j + 1) * limit, word.length())));
+                    }
+                    limitedSizeWords.addAll(split);
+                } else {
+                    limitedSizeWords.add(word);
+                }
+            }
+            for (String word : limitedSizeWords) {
+                String currentFormat = "";
+                //check for formatting and extract it
                 if (word.contains("§")) {
                     if (word.indexOf('§') < word.length() - 1) {
                         String format = String.valueOf(word.charAt(word.indexOf('§') + 1));
-                        if (format.matches("[0123456789abcdefklmnor]")) {
+                        if (format.matches("[0123456789abcdefklmnor]")) { //if matches any valid text format
                             currentFormat = "§" + format;
-                            formatChanged = true;
                         }
                     }
                 }
-                if (line.length() + 1 + word.length() < chars) {
-                    if(formatChanged) {
-                        line.append(lastFormat);
-                        formatChanged = false;
-                    }
+                if (line.length() + 1 + word.length() < limit) {
+                    //if line has not hit the char limit yet
                     line.append(word).append(" ");
                 } else {
+                    //line has hit the limit, wrap it preserving the last formatting
                     completeSplit.add(line.toString());
                     line = new StringBuilder();
                     line.append(lastFormat);
                     line.append(word).append(" ");
                 }
-                if(i == words.length - 1) {
-                    lastFormat = currentFormat;
-                }
+                if(!currentFormat.isEmpty()) lastFormat = currentFormat; //change last format if a new one was found in this iteration
             }
             completeSplit.add(line.toString());
         }
diff --git a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
index a374995cc..b3b04d307 100644
--- a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
@@ -542,8 +542,18 @@ public class ClientPacketHandler extends PacketHandler
     {
         if (!disconnected) {
             disconnected = true;
-            mc.changeWorld(null);
-            mc.displayGuiScreen(new GuiConnectFailed("disconnect.lost", s, errorLines));
+            try {
+                mc.changeWorld(null); // Leave current world
+            } catch (Exception e) {
+                e.printStackTrace();
+            }
+            try {
+                mc.displayGuiScreen(null); // Exit out of current GUI
+            } catch (Exception e) {
+                e.printStackTrace();
+            }
+
+            mc.displayGuiScreen(new GuiConnectFailed("disconnect.lost", s, errorLines)); // Open error message gui
         }
     }
 
diff --git a/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index cb82b49ef..d817112cb 100644
--- a/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -233,7 +233,7 @@ public class MobRenderer<T extends Mob> extends EntityRenderer<T>
         final float f1 = 1.6F;
         final float f2 = 0.01666667F * f1;
         GL11.glPushMatrix();
-        GL11.glTranslatef((float) d + 0.0F, (float) d1 + 2.3F, (float) d2);
+        GL11.glTranslatef((float) d + 0.0F, (float) d1 + entity.getHeadHeight() + 0.8f, (float) d2);
         GL11.glNormal3f(0.0F, 1.0F, 0.0F);
         GL11.glRotatef(-renderDispatcher.viewLerpYaw, 0.0F, 1.0F, 0.0F);
         GL11.glRotatef(renderDispatcher.viewLerpPitch, 1.0F, 0.0F, 0.0F);
diff --git a/src/main/java/net/minecraft/core/achievement/Achievement.java b/src/main/java/net/minecraft/core/achievement/Achievement.java
index 2324e211c..9f4b14e44 100644
--- a/src/main/java/net/minecraft/core/achievement/Achievement.java
+++ b/src/main/java/net/minecraft/core/achievement/Achievement.java
@@ -34,11 +34,6 @@ public class Achievement extends Stat
         this.x = x;
         this.y = y;
 
-        Achievements.minX = Math.min(Achievements.minX, x);
-        Achievements.maxX = Math.max(Achievements.maxX, x);
-        Achievements.minY = Math.min(Achievements.minY, y);
-        Achievements.maxY = Math.max(Achievements.maxY, y);
-
         this.parent = parent;
     }
 
